#include <bits/stdc++.h>
#define ll long long
using namespace std;
ll mod=1e9+7;
ll add(ll a,ll b) {
    a+=b;
    if(a<0) a+=mod;
    if(a>=mod) a-=mod;
    return a;
}
ll sub(ll a,ll b) {
    return (a*b)%mod;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll n,x=1e18,y=1e18,x2=0,y2=0;
    cin >> n;
    vector<pair<ll,ll>>V;
    for(ll i=0;i<n;i++) {
        ll xx,yy,R1=0,R2=0,R3=0,R4=0,maks=0;
        cin >> xx >> yy;
        V.push_back({xx,yy});
        map<ll,vector<pair<ll,ll>>>M;
        for(auto prvo:V) {
            for(auto drugo:V) {
                ll rez=0;
                for(auto trece:V) {
                    rez=add(rez,sub(abs(trece.first-prvo.first),abs(trece.second-drugo.second)));
                }
                maks=max(maks,rez);
                M[rez].push_back({prvo.first,drugo.second});
            }
        }
        //cout << "Sve:\n";
        //for(auto x:M[maks]) cout << x.first << ' ' << x.second << endl;
        cout << maks << endl;
    }
    return 0;
}